diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/dhcp6-client.h ns-3.45/src/internet-apps/model/dhcp6-client.h
--- ns-3.44/src/internet-apps/model/dhcp6-client.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/model/dhcp6-client.h	2025-06-01 20:34:45.314701300 -0700
@@ -0,0 +1,279 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#ifndef DHCP6_CLIENT_H
+#define DHCP6_CLIENT_H
+
+#include "dhcp6-duid.h"
+#include "dhcp6-header.h"
+
+#include "ns3/application.h"
+#include "ns3/inet6-socket-address.h"
+#include "ns3/net-device-container.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/socket.h"
+#include "ns3/traced-callback.h"
+#include "ns3/trickle-timer.h"
+
+#include <optional>
+
+namespace ns3
+{
+
+/**
+ * @ingroup dhcp6
+ *
+ * @class Dhcp6Client
+ * @brief Implements the DHCPv6 client.
+ */
+class Dhcp6Client : public Application
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    Dhcp6Client();
+
+    /**
+     * @brief Get the DUID.
+     * @return The DUID which identifies the client.
+     */
+    Duid GetSelfDuid() const;
+
+    /// State of the DHCPv6 client.
+    enum class State
+    {
+        WAIT_ADVERTISE,           // Waiting for an advertise message
+        WAIT_REPLY,               // Waiting for a reply message
+        RENEW,                    // Renewing the lease
+        WAIT_REPLY_AFTER_DECLINE, // Waiting for a reply after sending a decline message
+        WAIT_REPLY_AFTER_RELEASE, // Waiting for a reply after sending a release message
+    };
+
+    int64_t AssignStreams(int64_t stream) override;
+
+    // protected:
+    void DoDispose() override;
+
+    //  private:
+    void StartApplication() override;
+    void StopApplication() override;
+
+    /**
+     * @ingroup dhcp6
+     *
+     * @class InterfaceConfig
+     * @brief DHCPv6 client config details about each interface on the node.
+     */
+    class InterfaceConfig : public SimpleRefCount<InterfaceConfig>
+    {
+      public:
+        /**
+         * The default constructor.
+         */
+        InterfaceConfig();
+
+        /**
+         * Destructor.
+         */
+        ~InterfaceConfig();
+
+        /// The Dhcp6Client on which the interface is present.
+        Ptr<Dhcp6Client> m_client;
+
+        /// The IPv6 interface index of this configuration.
+        uint32_t m_interfaceIndex;
+
+        /// The socket that has been opened for this interface.
+        Ptr<Socket> m_socket;
+
+        /// The DHCPv6 state of the client interface.
+        State m_state;
+
+        /// The server DUID.
+        Duid m_serverDuid;
+
+        /// The IAIDs associated with this DHCPv6 client interface.
+        std::vector<uint32_t> m_iaids;
+
+        TrickleTimer m_solicitTimer;  //!< TrickleTimer to schedule Solicit messages.
+        Time m_msgStartTime;          //!< Time when message exchange starts.
+        uint32_t m_transactId;        //!< Transaction ID of the client-initiated message.
+        uint8_t m_nAcceptedAddresses; //!< Number of addresses accepted by client.
+
+        /// List of addresses offered to the client.
+        std::vector<Ipv6Address> m_offeredAddresses;
+
+        /// List of addresses to be declined by the client.
+        std::vector<Ipv6Address> m_declinedAddresses;
+
+        Time m_renewTime;     //!< REN_MAX_RT, Time after which lease should be renewed.
+        Time m_rebindTime;    //!< REB_MAX_RT, Time after which client should send a Rebind message.
+        Time m_prefLifetime;  //!< Preferred lifetime of the address.
+        Time m_validLifetime; //!< Valid lifetime of the address.
+        EventId m_renewEvent; //!< Event ID for the Renew event.
+        EventId m_rebindEvent; //!< Event ID for the rebind event
+
+        /// Store all the Event IDs for the addresses being Released.
+        std::vector<EventId> m_releaseEvent;
+
+        /**
+         * @brief Accept the DHCPv6 offer.
+         * @param offeredAddress The IPv6 address that has been accepted.
+         */
+        void AcceptedAddress(const Ipv6Address& offeredAddress);
+
+        /// Callback for the accepted addresses - needed for cleanup.
+        std::optional<Callback<void, const Ipv6Address&>> m_acceptedAddressCb{std::nullopt};
+
+        /**
+         * @brief Add a declined address to the list maintained by the client.
+         * @param offeredAddress The IPv6 address to be declined.
+         */
+        void DeclinedAddress(const Ipv6Address& offeredAddress);
+
+        /// Callback for the declined addresses - needed for cleanup.
+        std::optional<Callback<void, const Ipv6Address&>> m_declinedAddressCb{std::nullopt};
+
+        /**
+         * @brief Send a Decline message to the DHCPv6 server
+         */
+        void DeclineOffer();
+
+        /**
+         * @brief Cleanup the internal callbacks and timers.
+         *
+         * MUST be used before removing an interface to avoid circular references locks.
+         */
+        void Cleanup();
+    };
+
+    /**
+     * @brief Verify the incoming advertise message.
+     * @param header The DHCPv6 header received.
+     * @param iDev The incoming NetDevice.
+     * @return True if the Advertise is valid.
+     */
+    bool ValidateAdvertise(Dhcp6Header header, Ptr<NetDevice> iDev);
+
+    /**
+     * @brief Send a request to the DHCPv6 server.
+     * @param iDev The outgoing NetDevice
+     * @param header The DHCPv6 header
+     * @param server The address of the server
+     */
+    void SendRequest(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress server);
+
+    /**
+     * @brief Send a request to the DHCPv6 server.
+     * @param iDev The outgoing NetDevice
+     * @param header The DHCPv6 header
+     * @param server The address of the server
+     */
+    void ProcessReply(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress server);
+
+    /**
+     * @brief Check lease status after sending a Decline or Release message.
+     * @param iDev The incoming NetDevice
+     * @param header The DHCPv6 header
+     * @param server The address of the server
+     */
+    void CheckLeaseStatus(Ptr<NetDevice> iDev, Dhcp6Header header, Inet6SocketAddress server) const;
+
+    /**
+     * @brief Send a renew message to the DHCPv6 server.
+     * @param interfaceIndex The interface whose leases are to be renewed.
+     */
+    void SendRenew(uint32_t interfaceIndex);
+
+    /**
+     * @brief Send a rebind message to the DHCPv6 server.
+     * @param interfaceIndex The interface whose leases are to be rebound.
+     */
+    void SendRebind(uint32_t interfaceIndex);
+
+    /**
+     * @brief Send a Release message to the DHCPv6 server.
+     * @param address The address whose lease is to be released.
+     */
+    void SendRelease(Ipv6Address address);
+
+    /**
+     * @brief Handles incoming packets from the network
+     * @param socket incoming Socket
+     */
+    void NetHandler(Ptr<Socket> socket);
+
+    /**
+     * @brief Handle changes in the link state.
+     * @param isUp Indicates whether the interface is up.
+     * @param ifIndex The interface index.
+     */
+    void LinkStateHandler(bool isUp, int32_t ifIndex);
+
+    /**
+     * @brief Callback for when an M flag is received.
+     *
+     * The M flag is carried by Router Advertisements (RA), and it is a signal
+     * that the DHCPv6 client must search for a DHCPv6 Server.
+     *
+     * @param recvInterface The interface on which the M flag was received.
+     */
+    void ReceiveMflag(uint32_t recvInterface);
+
+    /**
+     * @brief Used to send the Solicit message and start the DHCPv6 client.
+     * @param device The client interface.
+     */
+    void Boot(Ptr<NetDevice> device);
+
+    /**
+     * @brief Retrieve all existing IAIDs.
+     * @return A list of all IAIDs.
+     */
+    std::vector<uint32_t> GetIaids();
+
+    /// Map each interface to its corresponding configuration details.
+    std::unordered_map<uint32_t, Ptr<InterfaceConfig>> m_interfaces;
+
+    Duid m_clientDuid;                             //!< The client DUID.
+    TracedCallback<const Ipv6Address&> m_newLease; //!< Trace the new lease.
+
+    /// Track the IPv6 Address - IAID association.
+    std::unordered_map<Ipv6Address, uint32_t, Ipv6AddressHash> m_iaidMap;
+
+    /// Random variable to set transaction ID
+    Ptr<RandomVariableStream> m_transactionId;
+
+    Time m_solicitInterval; //!< SOL_MAX_RT, time between solicitations.
+
+    /**
+     * Random jitter before sending the first Solicit. Equivalent to
+     * SOL_MAX_DELAY (RFC 8415, Section 7.6)
+     */
+    Ptr<RandomVariableStream> m_solicitJitter;
+
+    /// Random variable used to create the IAID.
+    Ptr<RandomVariableStream> m_iaidStream;
+};
+
+/**
+ * @brief Stream output operator
+ * @param os output stream
+ * @param h the Dhcp6Client
+ * @return updated stream
+ */
+std::ostream& operator<<(std::ostream& os, const Dhcp6Client& h);
+
+} // namespace ns3
+
+#endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/dhcp6-duid.cc ns-3.45/src/internet-apps/model/dhcp6-duid.cc
--- ns-3.44/src/internet-apps/model/dhcp6-duid.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/model/dhcp6-duid.cc	2025-06-01 20:34:45.314701300 -0700
@@ -0,0 +1,234 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#include "dhcp6-duid.h"
+
+#include "ns3/address.h"
+#include "ns3/assert.h"
+#include "ns3/ipv6-l3-protocol.h"
+#include "ns3/log.h"
+#include "ns3/loopback-net-device.h"
+#include "ns3/ptr.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("Dhcp6Duid");
+
+Duid::Duid()
+{
+    m_duidType = Duid::Type::LL;
+    m_hardwareType = 0;
+    m_time = Time();
+    m_identifier = std::vector<uint8_t>();
+}
+
+bool
+Duid::operator==(const Duid& o) const
+{
+    return (m_duidType == o.m_duidType && m_hardwareType == o.m_hardwareType &&
+            m_identifier == o.m_identifier);
+}
+
+bool
+operator<(const Duid& a, const Duid& b)
+{
+    if (a.m_duidType < b.m_duidType)
+    {
+        return true;
+    }
+    else if (a.m_duidType > b.m_duidType)
+    {
+        return false;
+    }
+    if (a.m_hardwareType < b.m_hardwareType)
+    {
+        return true;
+    }
+    else if (a.m_hardwareType > b.m_hardwareType)
+    {
+        return false;
+    }
+    NS_ASSERT(a.GetLength() == b.GetLength());
+    return a.m_identifier < b.m_identifier;
+}
+
+bool
+Duid::IsInvalid() const
+{
+    return m_identifier.empty();
+}
+
+uint8_t
+Duid::GetLength() const
+{
+    return m_identifier.size();
+}
+
+std::vector<uint8_t>
+Duid::GetIdentifier() const
+{
+    return m_identifier;
+}
+
+Duid::Type
+Duid::GetDuidType() const
+{
+    return m_duidType;
+}
+
+void
+Duid::SetDuidType(Duid::Type duidType)
+{
+    m_duidType = duidType;
+}
+
+uint16_t
+Duid::GetHardwareType() const
+{
+    return m_hardwareType;
+}
+
+void
+Duid::SetHardwareType(uint16_t hardwareType)
+{
+    NS_LOG_FUNCTION(this << hardwareType);
+    m_hardwareType = hardwareType;
+}
+
+void
+Duid::SetDuid(std::vector<uint8_t> identifier)
+{
+    NS_LOG_FUNCTION(this << identifier);
+
+    m_duidType = Type::LL;
+    uint8_t idLen = identifier.size();
+
+    NS_ASSERT_MSG(idLen == 6 || idLen == 8, "Duid: Invalid identifier length.");
+
+    switch (idLen)
+    {
+    case 6:
+        // Ethernet - 48 bit length
+        SetHardwareType(1);
+        break;
+    case 8:
+        // EUI-64 - 64 bit length
+        SetHardwareType(27);
+        break;
+    }
+
+    m_identifier.resize(idLen);
+    m_identifier = identifier;
+}
+
+void
+Duid::Initialize(Ptr<Node> node)
+{
+    Ptr<Ipv6L3Protocol> ipv6 = node->GetObject<Ipv6L3Protocol>();
+    uint32_t nInterfaces = ipv6->GetNInterfaces();
+
+    uint32_t maxAddressLength = 0;
+    Address duidAddress;
+
+    for (uint32_t i = 0; i < nInterfaces; i++)
+    {
+        Ptr<NetDevice> device = ipv6->GetNetDevice(i);
+
+        // Discard the loopback device.
+        if (DynamicCast<LoopbackNetDevice>(device))
+        {
+            continue;
+        }
+
+        // Check if the NetDevice is up.
+        if (device->IsLinkUp())
+        {
+            NS_LOG_DEBUG("Interface " << device->GetIfIndex() << " up on node " << node->GetId());
+            Address address = device->GetAddress();
+            if (address.GetLength() > maxAddressLength)
+            {
+                maxAddressLength = address.GetLength();
+                duidAddress = address;
+            }
+        }
+    }
+
+    NS_ASSERT_MSG(!duidAddress.IsInvalid(), "Duid: No suitable NetDevice found for DUID.");
+
+    NS_LOG_DEBUG("DUID of node " << node->GetId() << " is " << duidAddress);
+
+    // Consider the link-layer address of the first NetDevice in the list.
+    uint8_t buffer[16];
+    duidAddress.CopyTo(buffer);
+
+    std::vector<uint8_t> identifier(duidAddress.GetLength());
+    std::copy(buffer, buffer + duidAddress.GetLength(), identifier.begin());
+    SetDuid(identifier);
+}
+
+Time
+Duid::GetTime() const
+{
+    return m_time;
+}
+
+void
+Duid::SetTime(Time time)
+{
+    NS_LOG_FUNCTION(this << time);
+    m_time = time;
+}
+
+uint32_t
+Duid::GetSerializedSize() const
+{
+    return 4 + m_identifier.size();
+}
+
+void
+Duid::Serialize(Buffer::Iterator start) const
+{
+    Buffer::Iterator i = start;
+    i.WriteHtonU16(static_cast<std::underlying_type_t<Duid::Type>>(m_duidType));
+    i.WriteHtonU16(m_hardwareType);
+
+    for (const auto& byte : m_identifier)
+    {
+        i.WriteU8(byte);
+    }
+}
+
+uint32_t
+Duid::Deserialize(Buffer::Iterator start, uint32_t len)
+{
+    Buffer::Iterator i = start;
+
+    m_duidType = static_cast<Duid::Type>(i.ReadNtohU16());
+    m_hardwareType = i.ReadNtohU16();
+    m_identifier.resize(len);
+
+    for (uint32_t j = 0; j < len; j++)
+    {
+        m_identifier[j] = i.ReadU8();
+    }
+
+    return 4 + m_identifier.size();
+}
+
+size_t
+Duid::DuidHash::operator()(const Duid& x) const noexcept
+{
+    uint8_t duidLen = x.GetLength();
+    std::vector<uint8_t> buffer = x.GetIdentifier();
+
+    std::string s(buffer.begin(), buffer.begin() + duidLen);
+    return std::hash<std::string>{}(s);
+}
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/internet-apps/model/dhcp6-duid.h ns-3.45/src/internet-apps/model/dhcp6-duid.h
--- ns-3.44/src/internet-apps/model/dhcp6-duid.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/internet-apps/model/dhcp6-duid.h	2025-06-01 20:34:45.314701300 -0700
@@ -0,0 +1,201 @@
+/*
+ * Copyright (c) 2024 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Kavya Bhat <kavyabhat@gmail.com>
+ *
+ */
+
+#ifndef DHCP6_DUID_H
+#define DHCP6_DUID_H
+
+#include "ns3/buffer.h"
+#include "ns3/node.h"
+#include "ns3/nstime.h"
+
+namespace ns3
+{
+
+/**
+ * @ingroup dhcp6
+ *
+ * @class Duid
+ * @brief Implements the unique identifier for DHCPv6.
+ */
+class Duid
+{
+  public:
+    /**
+     * @brief Default constructor.
+     */
+    Duid();
+
+    /// DUID type.
+    enum class Type
+    {
+        LLT = 1, // Link-layer address plus time
+        EN,      // Vendor-assigned unique ID based on Enterprise Number
+        LL,      // Link-layer address
+        UUID,    // Universally Unique Identifier (UUID) [RFC6355]
+    };
+
+    /**
+     * @ingroup dhcp6
+     *
+     * @class DuidHash
+     * @brief Class providing a hash for DUIDs
+     */
+    class DuidHash
+    {
+      public:
+        /**
+         * @brief Returns the hash of a DUID.
+         * @param x the DUID
+         * @return the hash
+         *
+         * This method uses std::hash rather than class Hash
+         * as speed is more important than cryptographic robustness.
+         */
+        size_t operator()(const Duid& x) const noexcept;
+    };
+
+    /**
+     * @brief Initialize the DUID for a client or server.
+     * @param node The node for which the DUID is to be generated.
+     */
+    void Initialize(Ptr<Node> node);
+
+    /**
+     * @brief Check if the DUID is invalid.
+     * @return true if the DUID is invalid.
+     */
+    bool IsInvalid() const;
+
+    /**
+     * @brief Get the DUID type
+     * @return the DUID type.
+     */
+    Type GetDuidType() const;
+
+    /**
+     * @brief Set the DUID type
+     * @param duidType the DUID type.
+     */
+    void SetDuidType(Type duidType);
+
+    /**
+     * @brief Get the hardware type.
+     * @return the hardware type
+     */
+    uint16_t GetHardwareType() const;
+
+    /**
+     * @brief Set the hardware type.
+     * @param hardwareType the hardware type.
+     */
+    void SetHardwareType(uint16_t hardwareType);
+
+    /**
+     * @brief Set the identifier as the DUID.
+     * @param identifier the identifier of the node.
+     */
+    void SetDuid(std::vector<uint8_t> identifier);
+
+    /**
+     * @brief Get the time at which the DUID is generated.
+     * @return the timestamp.
+     */
+    Time GetTime() const;
+
+    /**
+     * @brief Get the length of the DUID.
+     * @return the DUID length.
+     */
+    uint8_t GetLength() const;
+
+    /**
+     * @brief Set the time at which DUID is generated.
+     * @param time the timestamp.
+     */
+    void SetTime(Time time);
+
+    /**
+     * @brief Get the DUID serialized size.
+     * @return The DUID serialized sized in bytes.
+     */
+    uint32_t GetSerializedSize() const;
+
+    /**
+     * @brief Serialize the DUID.
+     * @param start The buffer iterator.
+     */
+    void Serialize(Buffer::Iterator start) const;
+
+    /**
+     * @brief Deserialize the DUID.
+     * @param start The buffer iterator.
+     * @param len The number of bytes to be read.
+     * @return The number of bytes read.
+     */
+    uint32_t Deserialize(Buffer::Iterator start, uint32_t len);
+
+    /**
+     * @brief Comparison operator
+     * @param duid header to compare
+     * @return true if the headers are equal
+     */
+    bool operator==(const Duid& duid) const;
+
+    /**
+     * @brief Less than operator.
+     *
+     * @param a the first operand
+     * @param b the first operand
+     * @returns true if the operand a is less than operand b
+     */
+    friend bool operator<(const Duid& a, const Duid& b);
+
+    // TypeId GetInstanceTypeId() const override;
+    // void Print(std::ostream& os) const override;
+    // uint32_t GetSerializedSize() const override;
+    // void Serialize(Buffer::Iterator start) const override;
+    // uint32_t Deserialize(Buffer::Iterator start) override;
+
+  private:
+    /**
+     * @brief Return the identifier of the node.
+     * @return the identifier.
+     */
+    std::vector<uint8_t> GetIdentifier() const;
+
+    /**
+     * Type of the DUID.
+     * We currently use only DUID-LL, based on the link-layer address.
+     */
+    Type m_duidType;
+
+    uint16_t m_hardwareType;           //!< Valid hardware type assigned by IANA.
+    Time m_time;                       //!< Time at which the DUID is generated. Used in DUID-LLT.
+    std::vector<uint8_t> m_identifier; //!< Identifier of the node in bytes.
+};
+
+/**
+ * @brief Stream output operator
+ * @param os output stream
+ * @param duid The reference to the DUID object.
+ * @return updated stream
+ */
+std::ostream& operator<<(std::ostream& os, const Duid& duid);
+
+/**
+ * Stream extraction operator
+ * @param is input stream
+ * @param duid The reference to the DUID object.
+ * @return std::istream
+ */
+std::istream& operator>>(std::istream& is, Duid& duid);
+
+} // namespace ns3
+
+#endif
